/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Vapi from "..";
export interface CreateAgentDto {
    /** This is the OpenAI model that will be used. */
    model?: Vapi.CreateAgentDtoModel;
    /**
     * This is the voice that will be used.
     *
     * Pro Voices: steve, joseph, myra, paula, drew, phillip, paul, and mrb.
     *
     * Basic Voices: davis, jenny, aria, steffan, sara, and jason.
     */
    voice?: Vapi.CreateAgentDtoVoice;
    /** This is the agent’s name, just for your own reference. */
    name?: string;
    /** This is the system prompt, which sets the objective and background before the call. */
    context?: string;
    /** These are the functions that the agent can execute during the call. */
    functions?: Vapi.OpenAiFunction[];
    /**
     * This is the URL Vapi will send GET / POST requests for retrieving context, function calling, and end-of-call reports. All requests will be sent with customerPhoneNumber, botPhoneNumber, and all the agent parameters.
     *
     * Function Calling POST Request:
     * When the agent wants to call a function, we'll POST your callbackURL with `name` and `arguments`.
     * Respond with a JSON object of the result. For example: `{ result: "Hello world!" }` or `{ result: { temperature: "38 degrees" } }`. If empty, return `{}.
     *
     * End-of-Call Report POST Request:
     * You'll get `transcript`, `recordingUrl` and `summary` of the call.
     *
     * Context Retrieval GET Request:
     * If the agent's context isn't set, it'll ask for context before starting the call. Respond with `{ context: "You are an assistant..." }`
     */
    callbackUrl?: string;
    /** This is the number the agent will transfer to if it runs into any issues. */
    forwardingPhoneNumber?: string;
    /** Whether the AI should talk first when the call is connected. */
    startTalking?: boolean;
}
